<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Poll Hub</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.1.1/css/bootstrap.min.css" integrity="sha512-6KY5s6UI5J7SVYuZB4S/CZMyPylqyyNZco376NM2Z8Sb8OxEdp02e1jkKk/wZxIEmjQ6DRCEBhni+gpr9c4tvA==" crossorigin="anonymous" referrerpolicy="no-referrer" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.1.1/js/bootstrap.min.js" integrity="sha512-ewfXo9Gq53e1q1+WDTjaHAGZ8UvCWq0eXONhwDuIoaH8xz2r96uoAYaQCm1oQhnBfRXrvJztNXFsTloJfgbL5Q==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-/bQdsTh/da6pkI1MST/rWKFNjaCP5gBSY4sEBT38Q/9RBh9AH40zEOg7Hlq2THRZ" crossorigin="anonymous"></script>
        <script src="https://kit.fontawesome.com/07ecf7da9c.js" crossorigin="anonymous"></script>
        <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
        <script>
            let lightThemeSelected = false
            if (getCookie('colorCookie') == 'true') {
                changeToLightTheme();
                lightThemeSelected = true;
            }

    @* SOURCE : https://www.w3schools.com/js/js_cookies.asp *@
    function setCookie(cname, cvalue, exdays) {
        const d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        let expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    @* SOURCE : https://stackoverflow.com/questions/5968196/how-do-i-check-if-a-cookie-exists *@
    function getCookie(name) {
        var dc = document.cookie;
        var prefix = name + "=";
        var begin = dc.indexOf("; " + prefix);
        if (begin == -1) {
            begin = dc.indexOf(prefix);
            if (begin != 0) return null;
        }
        else
        {
            begin += 2;
            var end = document.cookie.indexOf(";", begin);
            if (end == -1) {
            end = dc.length;
            }
        }
        // because unescape has been deprecated, replaced with decodeURI
        //return unescape(dc.substring(begin + prefix.length, end));
        return decodeURI(dc.substring(begin + prefix.length, end));
    } 

        // each colors starts with --color- element (- extra)- color_order
        // property with extra in string switches value with property of same name without extra, for each --color
    function changeToLightTheme() 
    {
        let cssVarsNames = getAllCSSColorsNames();
        let cssVarsValuesByNames = getElementCSSVariables(cssVarsNames, document.documentElement);

        colorSwapToExtra(cssVarsValuesByNames);
    }
    function changeTheme() 
    {
        let cssVarsNames = getAllCSSColorsNames();
        let cssVarsValuesByNames = getElementCSSVariables(cssVarsNames, document.documentElement);

        colorSwapToExtra(cssVarsValuesByNames);

        if (getCookie('colorCookie') == 'true') {
            console.log('cookie= '+getCookie('colorCookie'))
            setCookie('colorCookie', 'false', 365);
        } else {
            console.log('cookie= '+getCookie('colorCookie'))
            setCookie('colorCookie', 'true', 365);
        }
    }

    // tries to swap colors for each key value
    function colorSwapToExtra(cssValuesByNames) {
        for (const [currentKey, currentValue] of Object.entries(cssValuesByNames)) {
            for (const [nextKey, nextValue] of Object.entries(cssValuesByNames)) {
                if (canSwapOneColor(currentKey, nextKey)) {
                    swapOneColor(currentKey, nextKey, currentValue, nextValue);
                }
            }
        }
    }
    // check if both keys matches the --color-element-extra pattern
    function canSwapOneColor(prevKey, nextKey) 
    {
        let isMatchingElement = false;

        let prevKeySplit = prevKey.split('--');
        prevKeySplit = prevKeySplit[1].split('-');
        
        let nextKeySplit = nextKey.split('--');
        nextKeySplit = nextKeySplit[1].split('-');

        // check if elements match, only one is extra 
        if ((prevKeySplit[1] == nextKeySplit[1]) && (prevKeySplit[2] != nextKeySplit[2]) && (prevKeySplit[2] != 'extra')) {
            //check if "element-extra-key" and "element-key" match on "key"
            if ((prevKeySplit[2] == nextKeySplit[3])) {
                isMatchingElement = true;
            }
        }

        if (isMatchingElement) {
            return true;
        } else {
            return false
        }
    }
    //swap 2 colors in the root
    function swapOneColor(prevKey, nextKey, prevValue, nextValue) 
    {
        let prevColor = prevValue;
        let nextColor = nextValue;

        let root = document.querySelector(':root');

        root.style.setProperty(prevKey, nextColor);
        root.style.setProperty(nextKey, prevColor);
    }

    @* SOURCE = https://stackoverflow.com/questions/48760274/get-all-css-root-variables-in-array-using-javascript-and-change-the-values *@
    @* modified to select only css var that starts with "--color" *@
    // could pass in an array of specific stylesheets for optimization
    function getAllCSSColorsNames(styleSheets = document.styleSheets) 
    { 
        var cssVars = [];
        // loop each stylesheet
        for(var i = 0; i < styleSheets.length; i++){
            // loop stylesheet's cssRules
            try{ // try/catch used because 'hasOwnProperty' doesn't work
                for( var j = 0; j < styleSheets[i].cssRules.length; j++){
                    try{
                    // loop stylesheet's cssRules' style (property names)
                    for(var k = 0; k < styleSheets[i].cssRules[j].style.length; k++){
                        let name = styleSheets[i].cssRules[j].style[k];
                        // test name for css variable signiture and uniqueness
                        if(name.startsWith('--color-') && cssVars.indexOf(name) == -1){
                            cssVars.push(name);
                        }
                    }
                    } catch (error) {}
                }
            } catch (error) {}
        }
        return cssVars;
    }

    @* SOURCE = https://stackoverflow.com/questions/48760274/get-all-css-root-variables-in-array-using-javascript-and-change-the-values *@
    function getElementCSSVariables (allCSSVars, element = document.body, pseudo)
    {
        var elStyles = window.getComputedStyle(element, pseudo);
        var cssVars = [];
        for(var i = 0; i < allCSSVars.length; i++){
            let key = allCSSVars[i];
            let value = elStyles.getPropertyValue(key)
            if(value){cssVars[key] = value;}
        }
        return cssVars;
    }

</script>

</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-dark navbar-custom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand navbar-custom nav-a" asp-area="" asp-controller="Home" asp-action="Index">Poll <div id="logo-website"></div> Hub</a>
                <!--<button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>-->
                <button class="navbar-toggler navbar-custom" type="button" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="navbar-toggler-icon navbar-dark navbar-custom"></span>
                </button>
                <div class="collapse navbar-collapse navbar-custom" id="collapsibleNavbar">
                    <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                        <div id="LightThemeDiv">
                            <i class="fas fa-lightbulb slideThreeIcon nav-a"></i>
                            <div class="slideThree slideThreeDiv"> 
                                <input type="checkbox" value="None" id="slideThree" class="lightThemeSwitch" name="check" onclick="changeTheme()"/>
                                <label for="slideThree"></label>
                            </div>
                            <script>
                                if (lightThemeSelected) {
                                    document.querySelector('.lightThemeSwitch').checked = true;
                                }
                            </script>
                        </div>
                        <ul class="navbar-nav  navbar-custom flex-grow-1  navbar-custom-flex">
                            @if (!User.Identity.IsAuthenticated)
                            {
                                <li class="nav-item">
                                    <a class="nav-link  navbar-custom" asp-area="" asp-controller="Login" asp-action="Register">Register</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link  navbar-custom" asp-area="" asp-controller="Login" asp-action="Login">Login</a>
                                </li>
                            }
                            @if (User.Identity.IsAuthenticated)
                            {
                                <li class="nav-item">
                                    <a class="nav-link  navbar-custom" asp-area="" asp-controller="Login" asp-action="Logout">Logout</a>
                                </li>
                            }
                        </ul>
                    </div>
                </div>
            </div>
        </nav>
    </header>
    <div class="container-centered">
        <main role="main" id="main-render-zone">
            @RenderBody()
        </main>
    </div>
    <hr class="cutter">
    <footer class="footer">
        <div class="container-footer">
            &copy; 2021 - Authn - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>
